from rocolib.api.components import FoldedComponent
from rocolib.api.composables.graph.Face import Face


class VLeg(FoldedComponent):
    def define(self):
        self.addParameter("height", 40, paramType="length")
        self.addParameter("width", 50, paramType="length")
        self.addParameter("thickness", 10, paramType="length")
        self.addParameter("taper", 0.5, paramType="ratio")

        self.addEdgeInterface("leftedge", "leg.e0", "height")
        self.addEdgeInterface("topedge", "leg.e1", "width")
        self.addEdgeInterface("rightedge", "leg.e2", "height")

    def assemble(self):
        h = self.getParameter("height")
        w = self.getParameter("width")
        t = self.getParameter("thickness")
        r = self.getParameter("taper") * t

        s = Face("", ((h, 0), (h, w), (0, w), (0, w-r), (h-t, w-t), (h-t, t), (0, r), (0,0)))
        self.addFace(s, "leg")

if __name__ == "__main__":
    VLeg.test()

